package com.tencent.subscribe.pb;

import com.google.protobuf.ByteString;
import org.apache.kafka.clients.producer.KafkaProducer;
import org.apache.kafka.clients.producer.ProducerRecord;

import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Properties;

public class ProtobufTest {

    public static void main(String[] args) {

        SubscribeProtobufData.Envelope  envelope  = SubscribeProtobufData.Envelope.newBuilder().setData(ByteString.copyFrom("test".getBytes(StandardCharsets.UTF_8))).build();

        send("test-topic","test-key",new String(envelope.toByteArray()));

    }


    public static void send(String topic, String key, String data) {
        Properties props = new Properties();
        props.put("bootstrap.servers", "127.0.0.1:9092");
        props.put("acks", "all");
        props.put("retries", 0);
        props.put("batch.size", 16384);
        props.put("linger.ms", 1);
        props.put("buffer.memory", 33554432);
        props.put("key.serializer", "org.apache.kafka.common.serialization.StringSerializer");
        props.put("value.serializer", "org.apache.kafka.common.serialization.StringSerializer");
        KafkaProducer producer = new KafkaProducer(props);
        producer.send(new ProducerRecord(topic,  data));
        producer.close();
    }

}
